/**
  *  \file client/chart/movemarkermode.h
  *  \brief Starchart Mode: WMoveMarkerChartMode
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_CHART_MOVEMARKERMODE_H
#define PCC_V2_CLIENT_CHART_MOVEMARKERMODE_H

#include "client/chart/markermode.h"
#include "game/lock.h"

/** Chart mode for moving a marker. Moves a lockable marker
    (MarkerDrawing) around. */
class WMoveMarkerChartMode : public WMarkerChartMode {
    void doChartLock(GChartLocation& loc, TLockMode lm, bool marked);
 public:
    WMoveMarkerChartMode(GDrawingContainer::iterator p);

    void onMove(GChartLocation& loc);
    void drawOverlays(GfxCanvas& can, GChartLocation& loc);
    bool handleEvent(const UIEvent& event, GChartLocation& loc);
};

#endif
