/**
  *  \file client/widgets/fleetmemlist.h
  *  \brief Fleet Member List
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_FLEETMEMLIST_H
#define PCC_V2_CLIENT_WIDGETS_FLEETMEMLIST_H

#include <vector>
#include "ui/listbox.h"

class WFleetMemberList : public UIListbox {
 public:
    WFleetMemberList(int lines, int width);
    ~WFleetMemberList();

    void setFleet(int fid);
    int  getFleet() const;
    void drawPart(GfxCanvas& can, int from, int to);
    int  getCurrentMemberId() const;

    bool isAnyMemberDirty() const;

 private:
    enum {
        fLeader = 0x8000,
        fTowed  = 0x4000,
        fTower  = 0x2000,
        fAway   = 0x1000,
        fIdMask = 0x0FFF
    };
    int current_fleet;
    std::vector<uint16_t> content;
};


inline int
WFleetMemberList::getFleet() const
{
    return current_fleet;
}

#endif
