/**
  *  \file client/widgets/gaparamview.h
  *  \brief Global Actions Parameter View
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_GAPARAMVIEW_H
#define PCC_V2_CLIENT_WIDGETS_GAPARAMVIEW_H

#include "client/wtile.h"
#include "cpluslib/holder.h"
#include "cpluslib/sigslot.h"

class UIButton;
class WGlobalActionParameter;

/** Global Actions Parameter View. Displays a WGlobalActionParameter
    object and lets the user operate on it. */
class WGlobalActionParameterView : public WTile {
    ObjectHolder h;
    WGlobalActionParameter& param;
    UIButton& btn_r;
    SignalConnection conn_changed;

    GfxPoint computeSize();
    void init();

    void onChange();

 public:
    WGlobalActionParameterView(WGlobalActionParameter& param);
    ~WGlobalActionParameterView();

    void drawData(GfxCanvas& can);
    bool handleEvent(const UIEvent& event, bool second_pass);
};

#endif
