/**
  *  \file game/planetpred.h
  *  \brief Planet Prediction
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_PLANETPRED_H
#define PCC_V2_GAME_PLANETPRED_H

class GPlanet;

class GPlanetEffectors {
 public:
    enum Effector {
        pe_Hiss,
        pe_RGA,
        pe_Pillage,
        pe_Meteor,
        pe_Heat50,
        pe_Cool50,
        pe_Heat100,
        pe_MAX
    };

    GPlanetEffectors();

    void clear();
    void add(Effector eff, int count);
    void set(Effector eff, int count);
    int get(Effector eff) const;
    int getNumTerraformers() const;

 private:
    int effectors[pe_MAX];
};

void computeTurn(GPlanet& planet, const GPlanetEffectors& eff);

#endif
