/**
  *  \file game/planettype.h
  *  \brief Planet Object Types
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_PLANETTYPE_H
#define PCC_V2_GAME_PLANETTYPE_H

#include "game/objtypes.h"
#include "game/planet.h"

/** Played planets type. Contains all planets that can be played. */
class GPlayedPlanetType : public GIndexedObjectType {
 public:
    GPlayedPlanetType(GUniverse& univ);
    GPlanet& getObjectByIndex(int index);
    GUniverse* getUniverseByIndex(int index);
    bool isValidIndex(int index) const;

 private:
    GUniverse& univ;
};

/** Any planet type. Contains all planets. */
class GAnyPlanetType : public GIndexedObjectType {
 public:
    GAnyPlanetType(GUniverse& univ);
    GPlanet& getObjectByIndex(int index);
    GUniverse* getUniverseByIndex(int index);
    bool isValidIndex(int index) const;

 private:
    GUniverse& univ;
};

/** Played starbases type. Contains all playable starbases. */
class GPlayedBaseType : public GIndexedObjectType {
 public:
    GPlayedBaseType(GUniverse& univ);
    GPlanet& getObjectByIndex(int index);
    GUniverse* getUniverseByIndex(int index);
    bool isValidIndex(int index) const;

 private:
    GUniverse& univ;
};

#endif
